<?

// $Id: core_class.php,v 1.3 2009/09/23 14:39:04 calicant Exp $

define ("MINI_PIC_LATO", 80);
define ("MINI_PIC_DIRNAME", "mini");


class core_image extends obj_class {

    var $config;

    function core_image($config) {
        $this->config = $config;

        if ($config['id']) {
            // se l'instanzazione del padre fallisce vuol dire che non è stato trovato l'oggetto nella library
            if (!parent::obj_class($config['id'], 'core', $config))
                return false;
            $this->getconfig();
        }
        else
            return false;
    }

    function getconfig() {
        $rs = select("SELECT * FROM core_image WHERE id='".$this->idobj."'",
                     $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));
        if ($rs->RecordCount())
            foreach ($rs->fields as $key => $val) {
                if (!$this->config[$key])
                    $this->config[$key] = $val;
            }
    }

    function add () {

        $param["height"] = $this->config["height"];
        $param["width"] = $this->config["width"];
        $param["size"] = $this->config["size"];
        $param["alt"] = $this->config["alt"];

        $last_insert_id = insert("core_image", $param, $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));

        if (!is_numeric($last_insert_id))
            die("Fatal Error: Could not add image to core_image table");

        // la miniatura
        if ($param["width"] > MINI_PIC_LATO) {
            
            $mini_pic_dir = $this->config["destination"] . "/" . MINI_PIC_DIRNAME;            
            if (!file_exists($mini_pic_dir))
                if (mkdir($mini_pic_dir, 0700) === false)
                    die("Fatal Error: Could not create directory \"" . $mini_pic_dir . "\"");

            my_resize_image (
                $this->config["destination"]  . "/" . $this->config["name"],
                MINI_PIC_LATO,
                (int)(($param["height"] * 80) / $param["width"]),
                $mini_pic_dir . "/" . $this->config["name"]
            );
            
        }


        parent::add($last_insert_id);
    }

    function remove() {

        // determinazione dell'id dell'oggetto padre
        $rs = select("SELECT `id` FROM `objlibrary` WHERE `idobj` = '" . $this->config["idobj"] . "' AND `objtype` = '" . $this->config["objtype"] . "' AND `iduser` = '" . $this->config["iduser"] . "' LIMIT 1", $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));

        if (!$rs || !$rs->RecordCount())
            die("Fatal Error: Could non find obj in parent library");
        else $idparent = $rs->fields('id');

        // rimozione immagine
        if (file_exists($this->config["destination"] . "/" . $this->config["name"])) {
            $r = unlink($this->config["destination"] . "/" . $this->config["name"]);
            if ($r === false)
                return $r;
        }
        // rimozione dell'eventuale miniatura
        if (file_exists($this->config["destination"] . "/" . "mini" . "/" . $this->config["name"]))
            unlink($this->config["destination"] . "/" . "mini" . "/" . $this->config["name"]);
        
        // eliminazione dell'immagine da tabella
        $rs = select("DELETE FROM `core_image` WHERE `id` = '" . $this->config["id"] . "' LIMIT 1", $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));
        if (!$rs)
            die("Fatal Error: Could not remove image (id = '" . $this->config["id"] . "')");

        // eliminazione dell'oggetto padre
        parent::remove($idparent);

    return true;
    }

    function edit($newdata) {

        $connh = $_SESSION['PRISCILLA_SESSION']->getvalue('connh');

        // determinazione dell'id dell'oggetto padre
        $rs = select("SELECT `id` FROM `objlibrary` WHERE `idobj` = '" . $this->config["idobj"] . "' AND `objtype` = '" . $this->config["objtype"] . "' AND `iduser` = '" . $this->config["iduser"] . "' LIMIT 1", $connh);

        if (!$rs || !$rs->RecordCount())
            die("Fatal Error: Could non find obj in parent library");
        else $idparent = $rs->fields('id');


        $rowrs = select("SELECT * FROM `core_image` WHERE `id` = " . $this->config["id"] . " LIMIT 1", $connh);

        if ($rowrs === false)
            die("Fatal error: could not modify image image (id = '" . $this->config["id"] . "') [1]");
        else {
            $dbquery = $connh->GetUpdateSql($rowrs, $newdata, $magicq=true);
            //echo $dbquery . "<br />\n";

            $rs = select($dbquery, $connh);
            if (!$rs)
                die("Fatal error: could not modify image (id = '" . $this->config["id"] . "') [2]");
        }

        parent::edit($idparent, $newdata);

    return true;
    }

    function render() {
        $attributes = $this->assembleattributes();

        $string = "<img id=\"image".$this->config['xmlid']."\" src=\"".PRISCILLA_UPLOAD_PATH."/".$this->config['iduser']."/".$this->config['name']."\" ".$attributes." />";

        return $string;
    }

}



class core_attach extends obj_class {

    function core_attach($config) {
        $this->config = $config;

        $this->connh = $_SESSION['PRISCILLA_SESSION']->getvalue('connh');

        if ($config['id']) {
            // se l'instanzazione del padre fallisce vuol dire che non e`stato trovato l'oggetto nella library
            if (!parent::obj_class($config['id'], 'core', $config))
                return false;
            $this->getconfig();
        }
        else
            return false;
    }

    function getconfig() {
        $rs = select("SELECT * FROM core_attach WHERE id='".$this->idobj."'",
                     $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));
        if ($rs->RecordCount())
            foreach ($rs->fields as $key => $val) {
                if (!$this->config[$key])
                    $this->config[$key] = $val;
            }

        if ($config['id'])
            return parent::obj_class($config['id'], 'core', $config);
        else
            return false;
    }

    function add () {
        $param["hits"] = 0;
        $param["code"] = $this->generate_new_code();
        $param["size"] = $this->config["size"];

        $last_insert_id = insert("core_attach", $param, $this->connh);

        if (!is_numeric($last_insert_id))
            die("Fatal Error: Could not add attach to core_attach table");

        return parent::add($last_insert_id);
    }

    function remove() {

        // determinazione dell'id dell'oggetto padre
        $rs = select("SELECT `id` FROM `objlibrary` WHERE `idobj` = '" . $this->config["idobj"] . "' AND `objtype` = '" . $this->config["objtype"] . "' AND `iduser` = '" . $this->config["iduser"] . "' LIMIT 1", $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));

        if (!$rs || !$rs->RecordCount())
            die("Fatal Error: Could non find obj in parent library");
        else $idparent = $rs->fields('id');

        // rimozione allegato
        if (file_exists($this->config["destination"] . "/" . $this->config["name"])) {
            $r = unlink($this->config["destination"] . "/" . $this->config["name"]);
            if ($r === false)
                return $r;
        }
        
        // eliminazione dell'allegato dalla tabella
        $rs = select("DELETE FROM `core_attach` WHERE `id` = '" . $this->config["id"] . "' LIMIT 1", $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));
        if (!$rs)
            die("Fatal Error: Could not remove attach (id = '" . $this->config["id"] . "')");

        // eliminazione dell'oggetto padre
        parent::remove($idparent);

    return true;


    }

    function edit($newdata) {

        $connh = $_SESSION['PRISCILLA_SESSION']->getvalue('connh');

        // determinazione dell'id dell'oggetto padre
        $dbquery = "SELECT `id` FROM `objlibrary` WHERE `idobj` = '" . $this->config["idobj"] . "' AND `objtype` = '" . $this->config["objtype"] . "' AND `iduser` = '" . $this->config["iduser"] . "' LIMIT 1";

        // echo $dbquery . "<br />\n";

        $rs = select($dbquery, $connh);

        if (!$rs || !$rs->RecordCount())
            die("Fatal Error: Could non find obj in parent library");
        else $idparent = $rs->fields('id');

        // in questo caso non ci sono campi da modificare nella tabella degli allegati

        parent::edit($idparent, $newdata);

        return true;
    }

    function render() {
        $attributes = $this->assembleattributes();

        $string = "<a id=\"attach".$this->config['xmlid']."\" href=\"".PRISCILLA_UPLOAD_PATH."/modules/core/d.php?c=".$this->config['code']."\" ".$attributes.">".$this->config['name']."</a>";

        return $string;
    }

    // controlla che il codice di download sia univoco
    // magari qui una funzione hash piu` furba
    function generate_new_code () {

    // ci proviamo 10 volte
    $goodcode = '';        

    for ($i = 0; $i < 10; $i++) {
            $tempcode = $this->randuid(5);
    
            $dbquery = "SELECT `id` FROM `core_attach` WHERE `code` = '$tempcode'";
            $rowrs = $this->connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->connh->ErrorMsg());

            if ($rowrs->RecordCount() == 0) {
                $goodcode = $tempcode;
                break;
            }   
        }

    return $goodcode;
    } // generate_new_code

    // generazione del codice casuale
    function randuid ($count) {

        srand((float) microtime() * 10000000);
        $chars = array_merge(range('a','z'), range('A','Z'), range('0','9'));
        $indices = array_rand($chars, $count);

        $result = "";
        foreach ($indices as $index)
            $result .= $chars[$index];

    return $result;
    } // randuid

}


?>
