<?

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

require_once $priscilla_local_path."lib/util.inc.php";
require_once $priscilla_local_path."packages/crypt/Rc4.php";
require_once $priscilla_local_path."modules/security/inc/config.inc.php";

class Security {

    function Security ($connh, $prefs = array()) {
        global $priscilla_local_path;

        $this->priscilla_local_path = $priscilla_local_path;
        $this->connh = $connh;
        $this->haveError = false;
        $this->lastError = "";
        $this->debug = $prefs['debug'];

        $this->default_prefs = array (
            'security_login_captcha' => 0,
            'security_good_passwd' => 0,
            'security_force_passwd_change' => 0,
            'security_crypted_setup' => 0,
            'security_https_login' => 0,
            'security_passwd_expire' => 0,
            'security_passwd_expire_days' => 30,
            'security_login_log' => 0,
            'security_login_failed_log' => 0,
            'security_login_notify_user' => 0,
            'security_login_notify' => 0,
            'security_login_notify_email' => "",
            'security_failed_login_delay' => 0,
            'security_login_old_info' => 0
        );

    } // Security

    function getSecurityPrefs () {

        $dbquery = "SELECT * FROM `" . SECURITY_TABLE_PREFS . "` LIMIT 1";
        $rs = $this->connh->Execute($dbquery);
        if (!$rs) {
            $this->haveError = true;
            $this->lastError = $this->connh->ErrorMsg();
            return array();
        }

        if ($rs->RecordCount() == 0) 
            return $this->default_prefs;

        $row = $rs->fields;
        unset($row['id']);


    return $row;
    } // getSecurityPrefs

    function saveSecurityPrefs ($prefs) {

        $prefs['id'] = 1;

        $rs = $this->connh->Execute("SELECT id FROM " . SECURITY_TABLE_PREFS . " WHERE id = '1' LIMIT 1");
        if (!$rs) {
            $this->haveError = true;
            $this->lastError = $this->connh->ErrorMsg();
            return 0;
        }

        $haveSavedPrefs = $rs->RecordCount();

        // update
        if ($haveSavedPrefs) {

            $rs = $this->connh->Execute("SELECT * FROM " . SECURITY_TABLE_PREFS . " WHERE id = '1'");
            if (!$rs) {
                $this->haveError = true;
                $this->lastError = $this->connh->ErrorMsg();
                return 0;
            }
 
            if ($rs->RecordCount() == 1)
                $dbquery = $this->connh->GetUpdateSql($rs, $prefs, true);
            else {
                $this->haveError = true;
                $this->lastError = "Prefs to update not found";
                return 0;
            }

            if (isset($prefs['security_crypted_setup']) && $prefs['security_crypted_setup'] == '1')
                $this->cryptSetupPassword();
            else $this->decryptSetupPassword();
        }
        // new insert
        else {
            $rs = $this->connh->Execute("SELECT * FROM " . SECURITY_TABLE_PREFS . " WHERE id = '-1'");
            if (!$rs) {
                $this->haveError = true;
                $this->lastError = $this->connh->ErrorMsg();
                return 0;
            }
            $dbquery = $this->connh->GetInsertSql($rs, $prefs, true);  

            if (isset($prefs['security_crypted_setup']) && $prefs['security_crypted_setup'] == '1')
                $this->cryptSetupPassword();
            else $this->decryptSetupPassword();
        }


        $rs = $this->connh->Execute($dbquery);

        if (!$rs) {
            $this->haveError = true;
            $this->lastError = $this->connh->ErrorMsg();
            return 0;
        }
 
    return 1;
    } // saveSecurityPrefs

    function cryptSetupPassword()
    {
        $svars = get_setup_vars($this->priscilla_local_path."adm/lib/setup.php");
        if ((!isset($svars['dbpasswcrpt']) || $svars['dbpasswcrpt'] == '0') && $svars['dbpassw'] != '')
        {
            $ckey = $this->priscilla_local_path;
            $cpwd = $svars['dbpassw'];

            if ($ckey{strlen($ckey) - 1} != "/")
                $ckey .= "/";
            $rc4 = new Crypt_RC4($ckey);
            $rc4->crypt($cpwd);
            $cpwd = base64_encode($cpwd);
            unset($rc4);

            $vars = array();
            $vars['dbpassw'] = $cpwd;
            $vars['dbpasswcrpt'] = '1';
            // variabili originali da includere comunque
            $vars['TESTING'] = $svars['TESTING'];
            $vars['priscilla_backup_maxmem'] = $svars['priscilla_backup_maxmem'];
            $vars['priscilla_server_path'] = $svars['priscilla_server_path'];

            save_setup_vars($this->priscilla_local_path."adm/lib/setup.php", $vars);
        }
        else return 1;
    }

    function decryptSetupPassword()
    {
        $svars = get_setup_vars($this->priscilla_local_path."adm/lib/setup.php");
        if (isset($svars['dbpasswcrpt']) && $svars['dbpasswcrpt'] == '1' && $svars['dbpassw'] != '')
        {
            $ckey = $this->priscilla_local_path;
            $cpwd = base64_decode($svars['dbpassw']);

            if ($ckey{strlen($ckey) - 1} != "/")
                $ckey .= "/";
            $rc4 = new Crypt_RC4($ckey);
            $rc4->decrypt($cpwd);
            unset($rc4);

            $vars = array();
            $vars['dbpassw'] = $cpwd;
            $vars['dbpasswcrpt'] = '0';
            // variabili originali da includere comunque
            $vars['TESTING'] = $svars['TESTING'];
            $vars['priscilla_backup_maxmem'] = $svars['priscilla_backup_maxmem'];
            $vars['priscilla_server_path'] = $svars['priscilla_server_path'];

            save_setup_vars($this->priscilla_local_path."adm/lib/setup.php", $vars);
        }
        else return 1;
    }

} // class Security

?>
