<?php
//  $Id: levlang.php,v 1.2 2010/07/05 14:09:54 calicant Exp $
//
//  Priscilla Developer Tools
//  levlang.php (4.8.2003)
//  calicant (calicant@ferrara.linux.it)
//
//  livella i file ASCII di lingua di Priscilla, si verifica che abbiano
//  le stesse variabili, dalla lingua generale corrente settata nel file
//  adm/lib/setup.php settabile anche dalla schermata ADM->DATABASE,
//  verso le altre lingue. Aggiunge e/o elimina le variabili modificate
//
//  esegue controllo su impaginazione:
//
//  eg:
//  $variabile	    = "contenuto della variabile";
//
//  7.10.2003	    viene richiesto il login per poter eseguire lo script
//  28.8.2003	    cambiati commenti, intestazione, corretto baco di
//		    percorso riga 31
//  21.8.2003	    genera report testuale sulle variabili mancanti (utile
//		    ai traduttori)
//  20.8.2003	    mantiene i commenti in lingua originale
//   7.8.2003	    corretto baco riguardante variabili su piu' righe (in
//		    scrittura si riportano a riga singola)
//

set_time_limit(60);

require "../../adm/lib/setup.php";

require "../../adm/lib/test_auth.php";

if ($_COOKIE['login'] != 'superuser')
    die("Authentication failed");


define("DEFINE_STRING", "define");
define("DEFINE_LUNG", strlen(DEFINE_STRING));

$debug = 0;

// alcuni settaggi
$PROG_NAME          = "LevLang";
$VERSION            = "0.7";
$DATA_VER           = "2004.2.5";
$LANG_PIETRA        = "ita";
$TOOLS_COLLECTION   = "Priscilla Developer Tools";


function test_define_begin ($filename, $nline, $line) {


    if ($line{DEFINE_LUNG} != ' ' || $line{DEFINE_LUNG + 1} != '(' || $line{DEFINE_LUNG + 2} != '"')
	die(
	    "$filename, line " . $nline . "<br />" .
	    "I have found a define in line:<br /><strong>$line</strong><br />" .
	    "but I want <strong>\"define (\"...</strong> Bailing out...<br /><br />\n"
	);
}

function test_define_end ($filename, $nline, $line, $lline) {

    if ($line{$lline - 1} != ';' || $line{$lline - 2} != ')' || $line{$lline - 3} != '"')
	die(
	    "<strong>$filename, line " . $nline  . "</strong><br />" .
	    "I have found a define in line:<br /><strong>$line</strong><br />" .
	    "but I want <strong>\"\");\" at end of line</strong><br />Bailing out<br /><br />\n"
	);
}


function is_a_good_lang_line ($line, &$lang_var, $filename, $nline) {    
    $line = trim($line);
    $pos = strpos($line, '=');
    if ($line{0} == '$' && $pos) {
        $lang_var = trim(substr($line, 0, $pos - 1));
        return 1;
    }
    
    $lline = strlen($line);

    if ($lline > DEFINE_LUNG + 3 && substr($line, 0, DEFINE_LUNG) == DEFINE_STRING) {
	// una serie di controlli sullo stile del defined

	test_define_begin ($filename, $nline, $line);
	test_define_end ($filename, $nline, $line, $lline); 

	// alla ricerca del nome della variabile
	$lang_var = '$';
	$lastc = '';

	for ($i = DEFINE_LUNG + 3; $i < $lline; $i++) {
	    if ($line{$i} == '"' && $lastc != "\\") {
		return 1;
	    }
	    else {	
		$lastc = $line{$i};
		$lang_var .= $lastc;
	    }
	} // for
	
	
	die("***I was not able to get variable name from file $filename, line $nline<br /><strong>$line</strong><br />\n");
    }
    
return 0;
}

function dollartodefine ($line) {

    $originalline = $line;
    $line = trim($line);
    $pos = strpos($line, '=');
    if ($line{0} == '$' && $pos && $line{strlen($line) - 1} == ';') {
        $lang_var = trim(substr($line, 1, $pos - 1));
	$lang_value = substr(trim(substr($line, $pos + 1)), 0, -1);
	return "define (\"" . $lang_var . "\", " . $lang_value . ");\n"; 
    }
    else return $originalline;
}

function extract_varname_varvalue_from_define ($filename, $currentline, $line, $lline, &$lang_var, &$currentval) {

    $lang_var = '';
    $lastc = '';
    $foundbegin = false;
    $foundend = false;
	
    for ($k = DEFINE_LUNG + 3; $k < $lline; $k++) {
	if ($line{$k} == '"' && $lastc != "\\") {
	    $lang_var = '$' . $lang_var;
	    $currentval = '';
	    $lastc = '';
	    $startedval = false;

	    for ($j = $k + 1; $j < $lline; $j++) {
		if ($line{$j} == '"' && !$startedval) {
		    $startedval = true;
			$foundbegin = true;
			continue;
		}

		if ($startedval) {
		    if ($line{$j} == '"' && $lastc != "\\") {
			$foundend = true;
			break;
		    }
		    $lastc = $line{$j};
		    $currentval .= $lastc;
		} // if ($startedvale
	    }  // for

	    break;
	}
	else {
	    $lastc = $line{$k};
	    $lang_var .= $lastc;
        }
    } // for

    if (!$foundbegin || !$foundend) {
	$nline = $currentline + 1;
	die("Errore Fatale: qualcosa non mi piace intorno alla linea $nline di $filename");
    }
} // extract_varname_varvalue_from_define 

function makecommentfile ($filename, &$originaldata) {

    if (!file_exists($filename))
        die("Fatal Error: File does not exist\n");
            
    $filetext = file($filename);
    $incomm = 0;
    $lcomment = '';

    for ($i = 0; $i < count($filetext); $i++) {
        $line = trim($filetext[$i]);
        
        if ($line == '') {
            $lcomment .= $filetext[$i];
            $incomm = 1;
            continue;
        }
        
        if (strlen($line) > 1 && $line{0} == '/' && $line{1} == '/') {
            $lcomment .= $filetext[$i];
            $incomm = 1;
            continue;
        }

        if ($line{0} == '$' && strpos($line, '=') && $incomm) {
            $pos = strpos($line, '=');
            $lang_var = trim(substr($line, 0, $pos - 1));
            $originaldata[$lang_var] = $lcomment;
            $incomm = 0;
            $lcomment = '';
        }
	

	// per le righe define
	$lline = strlen($line);

	if ($lline > DEFINE_LUNG + 4 && substr($line, 0, DEFINE_LUNG) == DEFINE_STRING) {
	    // una serie di controlli sullo stile del defined
	    $nline = $i + 1;

	    test_define_begin ($filename, $nline, $line);
	    test_define_end ($filename, $nline, $line, $lline);

	    extract_varname_varvalue_from_define ($filename, $i, $line, $lline, $lang_var, $currentval);
	    $originaldata[$lang_var] = $lcomment;
            $incomm = 0; 
            $lcomment = '';
	}

    } // for
}

function makestructfile ($filename, &$originaldata) {

    if (!file_exists($filename))
        die("Fatal Error: File does not exist\n");
        
    $filetext = file($filename);
    $elenco_var = array();

    $founddollar = false;
    $founddefine = false;

    // alla ricerca delle variabili perdute
    for ($i = 0; $i < count($filetext); $i++) {
        $line = trim($filetext[$i]);
        $templine = '';
        
        if ($line{0} == '$' && strpos($line, '=')) {
        
	    $founddollar = true;

            if ($line{strlen($line) - 1} != ';')  {
                $templine = $line . ' ';
                $contavolte = 0;
                $k = $i + 1;
                $havetowork = 1;
                while ($havetowork && $contavolte < 100) {
                    $subline = trim($filetext[$k]);
                    if ($subline{0} == '$')
                        die("Errore Fatale: qualcosa non mi piace intorno alla linea $k di $filename");
                    $templine .= $subline . ' ';
                    if ($subline{strlen($subline) - 1} == ';' && $subline{strlen($subline) - 2} == '"')
                        $havetowork = 0;
                    else {
                        $k++;
                        $contavolte++;
                    }
                } // while
                                                
                if ($havetowork)
                    die("$filename: Errore Fatale: Loop in parsing. Mi fermo per la tua salvezza\n");
            } // if
            
            
            $pos = strpos($line, '=');
            $lang_var = trim(substr($line, 0, $pos - 1));
            $elenco_var[] = $lang_var;
            if ($templine == '')
                $originaldata[$lang_var] = $filetext[$i];
            else
                $originaldata[$lang_var] = $templine;
        } // if


	// per le righe define
	$lline = strlen($line);

	if ($lline > DEFINE_LUNG + 4 && substr($line, 0, DEFINE_LUNG) == DEFINE_STRING) {

	    $founddefine = true;

	    // una serie di controlli sullo stile del defined
	    $nline = $i + 1;

	    test_define_begin ($filename, $nline, $line);
	    test_define_end ($filename, $nline, $line, $lline);

	    extract_varname_varvalue_from_define ($filename, $i, $line, $lline, $lang_var, $currentval);
	    $elenco_var[] = $lang_var;
	    $originaldata[$lang_var] = $lang_var . " = \"" . $currentval . "\";\n";
	    //echo "$originaldata[$lang_var]<br />\n";
	}

    } // for
    

    if ($founddollar && $founddefine)
	    die("$filename: Errore fatale: in questo file ho trovato define misti a variabili. L'uno o l'altro!\n");

return $elenco_var;

}


function stampa_tenda_lang_target() {
global $priscilla_local_path;


    if ($priscilla_local_path{strlen($priscilla_local_path) - 1} != '/')
	$priscilla_local_path .= '/';

    echo
	"<select name=\"langdir\" size=\"1\">\n" .
	"<option value=\"" . $priscilla_local_path . "tools/lang" . "\">" . $priscilla_local_path . "tools/lang" . "</option>\n";


    foreach (glob($priscilla_local_path . "modules/*") as $filename) {
	$langdir = $filename . "/" . "lang";

	////////////// pezza per il sottomodulo di shop: potrebbe poi essere una lista, ma no,
	////////////// altri moduli, anche di tipo shop saranno tutti al livello modules
	
	$tmodname = basename($filename);

	if ($tmodname == 'shop')
	    $langdir = $filename . "/" . "pren_appartamenti" . "/" . "lang"; 
	////////////////////////////////

	if (file_exists($langdir) && is_dir($langdir))
	echo "<option value=\"" . $langdir . "\">" . $langdir . "</option>\n";
    }
    echo "</select>\n";
}


if (isset($reportsave) && $reportsave == 'y') {

    $adesso = date("Y-m-d");
    $myfilename = 'levlang_report_' . $adesso . '.txt'; 

    header("Pragma: no-cache");
    header("Expires: 0");
    //header("Content-type: text/plain");
    header("Content-type: application/octet-stream");
    header("Content-disposition: inline; filename=$myfilename");
    header("Content-disposition: filename=$myfilename");

    echo '=== ' . $PROG_NAME . ' ' . $VERSION . ", Report " . $adesso . " === \n\n";
       
    if ($PRISCILLA_SESSION->exists('levlang_report_text'))
	$levlang_report_text = $PRISCILLA_SESSION->getvalue('levlang_report_text');
 
    while (list($k, $v) = each($levlang_report_text))
        echo
            "\n--- FILE LINGUA \"" . strtoupper($k) . "\" ---\n" .        
            $levlang_report_text[$k];

    $PRISCILLA_SESSION->remove('levlang_report_text');
    die('');
} // if (isset($reportsave)

///////////////////////////////////////////////////////////////

// stampa la testa di pagina
echo <<< END
<html><head>
<title>$TOOLS_COLLECTION - $PROG_NAME</title></head>
<body bgcolor="#e9e9e9">
<br /><br />
<center>
END;

if (isset($note)) {

echo $PROG_NAME . " " . $VERSION . " (" . $DATA_VER . ") - " . '$Id: levlang.php,v 1.2 2010/07/05 14:09:54 calicant Exp $' . "<br />\n";

echo <<< END
</center>
<br />
<h4><u>Formato dei file di lingua:</u></h4>
<br />
Il programma esamina i file <strong>*diz</strong> presenti nella directory <strong>lang</strong> in riferimento alla versione corrente
 di <strong><span COLOR="red">Priscilla</span></strong> alla ricerca delle <strong>variabili PHP</strong> in essi definite.<br />
Nella scrittura dei file, <strong>oltre</strong> alle variabili, lascia filtrare:<br />
<ul>
	<li>TAG PHP di fine e inizio codice (accettati &lt;php, &lt;?, ?&gt;)</li>
	<li>Linee vuote</li>
	<li>Commenti (soltanto la forma //)</li>
</ul>
Si accettano in ingresso anche assegnamenti di valori a variabili su linee spezzate con la
 limitazione che il segno di uguaglianza va necessariamente posto sulla stessa linea del nome di variabile:<br /><br />
<em>\$nomevar =<br />&nbsp;&nbsp;&nbsp;"descrizione";</em><br />
<br />
END;

echo
    "Nell'assegnamento alle variabili la corretta terminazione della stringa dovra' essere: <strong>\";</strong><br />";
    
echo <<< END
<h4><u>Nuovo formato: define...</u></h4>
<br />
I nuovi moduli di Priscilla aggiunti hanno dizionari che contengono define piuttosto che variabili.<br />
Il modulo <em>shop</em> e <em>catalogo</em> mantengono la vecchia struttura di lingua.<br />
<strong>LevLang</strong> accetta il nuovo formato
<br /><br />
<em>define ("NOMEDEFINIZIONE", "valore");</em>
<br /><br />
Si noti che:<br /><br />
<li>uno spazio segue la parola <em>define</em>;</li>
<li>sia il nome che il valore sono racchiusi da virgolette doppie;</li>
<li>la definizione deve essere su una unica riga.</li>
<br />
<h4><u>Limitazioni:</u></h4>
<br />
Aggiunta di nuove varibili in testa a una sezione preesistente fa risultare che il commento di sezione della lingua originale
sia sostituito dal commento attuale italiano.<br />
Non si possono inserire variabili e define nel medesimo file.
<br /><br /><center><a href="$PHP_SELF">Torna a $PROG_NAME</a></center><br />
END;

} // if (isset($note)


if ($bSubmit == "Vai!" && isset($langdir) && trim($langdir) != '' && isset($opmode)) {


    $templangdir = basename(dirname(dirname($langdir)));

    // che la barra non si sa mai...
    if ($templangdir{strlen($templangdir) - 1} == '/')
	$templangdir = substr($templangdir, 0, -1);

    // per come e' strutturato nei livelli di directory il modulo shop si interpreta in dollar mode pur essendo in modules
    $define_save_mode = true;

    // una eccezione ai moduli vecchia maniera: catalogo
    if ($templangdir == 'modules') {
	$modulename =  basename(dirname($langdir));

	if ($modulename{strlen($modulename) - 1} == '/')
	    $modulename = substr($modulename, 0, -1);

	if ($modulename == 'catalogo')
	    $define_save_mode = false;
    }

    // scansione alla ricerca dei linguaggi presenti
    $handle = opendir($langdir); 
    
    while ($file = readdir($handle)) { 
	    if (!ereg('^\.', $file) && is_dir($langdir . "/" . $file) && !ereg('^CVS', $file))  {             
            $elenco_lang_dirs[] = $file;            
            // e andiamo a prendere anche l'elenco dei files
            $hh = opendir($langdir . "/" . $file);
            while ($filelang = readdir($hh)) { 
                $currfilelang = $langdir . "/" . $file . "/" . $filelang;
        	    if (!ereg('^\.', $filelang) && ereg('.diz$', $filelang) && is_file($currfilelang)) {                
                    $datalang = array();
                    $elenco_lang_files[$file][] = $filelang;
                    $struct_lang_files[$file][$filelang] = makestructfile($currfilelang, $datalang);
                    $original_lang_data[$file][$filelang] = $datalang;
                    $datacomment = array();
                    makecommentfile($currfilelang, $datacomment);
                    $struct_comm_files[$file][$filelang] = $datacomment;                                        
                    unset ($datalang);
                }
            } // while
            closedir($hh);
	    }
    } // while
    closedir($handle);
        

    

    if (!in_array($LANG_PIETRA, $elenco_lang_dirs))
        die("<br /><strong>Impossibile procedere poiche' non e' presente la lingua presa a modello (\"$LANG_PIETRA\")</strong><br />\n");

    echo "<strong>$PROG_NAME $VERSION ($DATA_VER)</strong><br /><br /><table align=\"center\" cellpadding=\"5\" cellspacing=\"5\" border=\"1\">\n";

    echo "<center>Salvo i file in... ";

    if ($define_save_mode)
	echo "<strong>define mode";
    else
	echo "<strong>dollar mode";

    echo "</strong></center><br /><br />\n";

    // stampa delle totale delle variabili contenute nei varii files
    sort($elenco_lang_files[$LANG_PIETRA]); // se manca questa ci scombiniamo   
    foreach ($elenco_lang_dirs as $lingua) {
        // un ordinamento sui files
	if (is_array($elenco_lang_files[$lingua]))
            sort($elenco_lang_files[$lingua]);
        $colspan = count($elenco_lang_files[$LANG_PIETRA]) + 1;
        if (!$count) {
            echo "<tr><th bgcolor=\"#cccccc\"align=\"center\" colspan=\"$colspan\"><strong>DISTRIBUZIONE NUMERO VARIABILI PER LINGUA</strong></th></tr>" .
                "<tr><td align=\"center\"><strong>LINGUA</strong></td>";
            for ($i = 0; $i < count($elenco_lang_files[$LANG_PIETRA]); $i++) {
                echo "<td align=\"center\"><strong>" . $elenco_lang_files[$LANG_PIETRA][$i] . "</strong></td>";
            }
            echo "</tr>\n";            
        }
        
        echo "<tr><td align=\"center\"><strong>$lingua</strong></td>";
        
        for ($i = 0; $i < count($elenco_lang_files[$lingua]); $i++) {        
            $currnomefile = $elenco_lang_files[$lingua][$i];
            echo "<td align=\"center\">" . count($struct_lang_files[$lingua]["$currnomefile"]) , "</td>\n";
        } // for
        echo "</tr>\n";
        
        $count++;        
    } // foreach
    echo "</table>\n";

    if ($simula == 'ok')
        echo "<h3>Attenzione: simula ma non salva le modifiche</h3>\n";
    echo
        "<br /><br />Inizio a livellare (modo = <strong>'$opmode'</strong>) i file di lingua sulla base delle variabili contenute nella directory <strong>'$LANG_PIETRA'</strong>...</center><br /><br />\n";


    $levlang_report_text = array();

    for ($i = 0; $i < count($elenco_lang_files[$LANG_PIETRA]); $i++) {
        $currfilename = $elenco_lang_files[$LANG_PIETRA][$i];
        foreach ($elenco_lang_dirs as $lingua) {
            if ($lingua == $LANG_PIETRA)
                continue;
                
            $examinandofile = $langdir . "/" . $lingua . "/" . $currfilename;
            $pietrafile = $langdir . "/" . $LANG_PIETRA . "/" . $currfilename;
            
            // se il file di destinazione non esiste lo creo
            if (!file_exists($examinandofile )) {
                echo "!!! Il file <strong>$examinandofile</strong> non esiste... ";
                flush();
                $origfile = file($pietrafile);
                // salviamo i risultati
                $fp = fopen($examinandofile, "w");
                if (!$fp)
                    die("Fatal Error: could not write file: '$examinandofile'");
                for($s = 0; $s < count($origfile); $s++)
                    fputs($fp, $origfile[$s]);
                fclose($fp);
                echo " CREATO<br />\n";
                flush();
                continue;
            }
                        
            echo "[***] verifico <strong>" . $examinandofile . "</strong> contro $pietrafile: ";
            flush();


            // un controllo in pi&Atilde;�
            if (!isset($struct_lang_files[$lingua][$currfilename])) {
                echo "<br />!!! Impossibile confrontare con $examinandofile: <strong>file non esiste</strong><br />\n";                
                flush();
                continue;
            }

            if ($opmode == 'leveldiff') {
                $difflang = array_diff($struct_lang_files[$LANG_PIETRA][$currfilename],
                    $struct_lang_files[$lingua][$currfilename]);

                $contadiff = count($difflang);
            } // if opmode               

            if (($contadiff && $opmode == 'leveldiff') || $opmode == 'levelall') {
                
                echo "<span color=\"red\">LIVELLO...</span><br />\n";
                flush();
                
                $raw_lang_data = file($pietrafile);
                
                if ($opmode == 'leveldiff') {
                    echo "<strong>||| al file $examinandofile mancano le variabili:</strong> ";
                    $levlang_report_text[$lingua] .= "Nel file \"" . basename($examinandofile) . "\" sono da tradurre le variabili:\n\n";
                    foreach ($difflang as $currvar) {
                        echo " $currvar&nbsp;&nbsp";
                        $levlang_report_text[$lingua] .= $currvar . "\n";
                        }
                    echo "<br />\n";
                    flush();
                }                    


                // in questo caso ci sono differenze e allora sincronizziamo
                for ($k = 0; $k < count($raw_lang_data); $k++) {
                    $line = $raw_lang_data[$k];
                    if (is_a_good_lang_line($line, $lang_var, $currfilename, $k + 1)) {
                        if (in_array($lang_var, $struct_lang_files[$lingua][$currfilename]))  {
                            // se prima di questa variabile nel file originale c'erano commenti,
                            // allora si preservano, sempre che ci sia commento nella lingua PIETRA
                            if (isset($struct_comm_files[$lingua][$currfilename][$lang_var]) &&
                                isset($struct_comm_files[$LANG_PIETRA][$currfilename][$lang_var]))
                                    $atosave[] = $struct_comm_files[$lingua][$currfilename][$lang_var];
                            
                            $atosave[] = $original_lang_data[$lingua][$currfilename][$lang_var];
                        }
                        else {
                            echo "--- aggiungo la variabile <span color=\"red\">$lang_var</span><br />";
                            // se la nuova variabile  ha un commento italiano associato
                            if (isset($struct_comm_files[$LANG_PIETRA][$currfilename][$lang_var]))
                                    $atosave[] = $struct_comm_files[$LANG_PIETRA][$currfilename][$lang_var];

                            // adesso il contenuto
                            $tline = trim($line);
                            
                            // eventualmente si compattano le multirighe...
                            if ($tline{strlen($tline) - 1} == ';')
                                $atosave[] = $line;
                            else
                                $atosave[] =
                                    $original_lang_data[$LANG_PIETRA][$currfilename][$lang_var] . "\n";
                                
                            flush();
                        }
                    } // if is_a_good_lang_line
                    else {
                        // se la linea non &Atilde;� buona va inserita soltanto se rispetta certi canoni
                        // tutto cio' soprattuto per la gestione delle linee spezzate
                        $tline = trim($line);                        
                        if ($tline == '<?php' || $tline == '<?'  || $tline == '?>')
                                $atosave[] = $line;
                        else ;

                    } // fine caso della linea non buona
                } // for



                // salviamo i risultati
                if ($simula != 'ok') {
                    $fp = fopen($examinandofile, "w");
                    if (!$fp)
                        die("Fatal Error: could not write file: '$examinandofile'");

		    if ($define_save_mode)
			for($s = 0; $s < count($atosave); $s++)
			    fputs($fp, dollartodefine($atosave[$s]));
		    else
			for($s = 0; $s < count($atosave); $s++)
			    fputs($fp, $atosave[$s]);


                    fclose($fp);
                    unset($atosave);
                } // if simula
                
            } // if $contadiff
            else  {
                echo "NON LIVELLO<br />\n";
                flush();
            }                
            
        } // foreach        
    } // for

    if (isset($levlang_report_text) && count($levlang_report_text)) {
	$PRISCILLA_SESSION->add('levlang_report_text', $levlang_report_text);
        $salvareport = " | <a href=\"$PHP_SELF?reportsave=y\">Salva report</a>";        
    }
    echo "<br /><br /><center><a href=\"$PHP_SELF\">Torna a $PROG_NAME</a>$salvareport</center><br />\n";

}
else if (!isset($note)) {
echo <<< EOF
<h4><span color="red"><strong>$PROG_NAME ($VERSION)</strong></span>: Analizza e "livella" (*) i file di lingua Priscilla...</h4>
<h4>Cerco i file nella directory principale di Priscilla (default) oppure nella langdir del modulo:&nbsp;</h4>
<form method="POST">
EOF;
stampa_tenda_lang_target();
echo <<< EOF
<h4>Nota bene: i file saranno sincronizzati alla versione nazionale: "$LANG_PIETRA"</h4>
<br />
Livella solo i file cui mancano variabili<input type="radio" name="opmode" value="leveldiff" checked />&nbsp;&nbsp;&nbsp;
Livella tutti i file<input type="radio" name="opmode" value="levelall" /><br /><br />
Simula ma non salvare le modifiche&nbsp;<input type="checkbox" name="simula" checked value="ok" />&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="bSubmit" value="Vai!">
</form>
<br /><br /><br />
(*) In questo modo di operare si livellano i file di lingua sulla lingua modello ($LANG_PIETRA)<br />
I commenti e le intestazioni delle varie sezioni per quanto possibile sono mantenuti nella loro lingua originale (GMI = gestione multipla intestazioni)<br />
Alcune <a href="$PHP_SELF?note">note aggiuntive</a> sul formato dei file in ingresso e sulle limitazioni conosciute sono disponibili.
EOF;
}

// stampa il piede di pagina
echo <<< EOF
</body>
</html>
EOF;

?>
